// Importerer ndvendige pakker
import gl4java.*;			// For  kunne implementere GLEnum (gir tilgang til en rekke fields (variablene i store bokstaver))
import gl4java.utils.glut.*;	// Open GL's "verktyboks"

/**
 * <strong>Description:</strong><br>
 * Subclass of the abstract class Material, 
 * which supplies all necessary common methods for its subclasses.<br>
 * GreenMaterial supplies methods that are particular to the component.<br>
 * Used for making a green material for the different stands of the hourglass.<br>
 * <br><strong>All code is extensively commented in Norwegian.</strong>
 * @author Therese Rsholdt, Grafisk Databehandling 2003, Hi
 * @version 0.1
 */
public class GreenMaterial extends Material
{
    /**
     * GreenMaterial constructor
     */
    public GreenMaterial( GLFunc gl)
    {
        super(gl);
    }
    
    /**
     * Enables the GreenMaterial
     * @param sideChoice the constant to indicate which side 
     * of the objekt should have this material, can be GL_FRONT_AND_BACK, 
     * GL_FRONT or GL_BACK. 
     */
    public void enableMaterial(int sideChoice)
    {
        // Hvis det er materiale p begge sider skal det ogs reagere p lys p begge sider
        if (sideChoice == GL_FRONT_AND_BACK)
        {
            gl.glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);
        }
        // Grnnfarge
        float amb2[]={0.0f, 0.05f, 0.0f, 1.0f};
        float diff2[]={0.4f, 0.5f, 0.4f, 1.0f};
        float spec2[]={0.04f, 0.7f, 0.04f, 1.0f};
        float shine2=32.0f;
        
        gl.glMaterialfv(sideChoice, GL_AMBIENT, amb2);
        gl.glMaterialfv(sideChoice, GL_DIFFUSE, diff2);
        gl.glMaterialfv(sideChoice, GL_SPECULAR, spec2);
        gl.glMaterialf(sideChoice, GL_SHININESS, shine2);
    }
}