// Importerer ndvendige pakker
import gl4java.*;			// For  kunne implementere GLEnum (gir tilgang til en rekke fields (variablene i store bokstaver))
import gl4java.utils.glut.*;	// Open GL's "verktyboks"

/**
 * <strong>Description:</strong><br>
 * Supplies all necessary common methods for its subclasses.<br>
 * <br><strong>All code is extensively commented in Norwegian.</strong>
 * @author Therese Rsholdt, Grafisk Databehandling 2003, Hi
 * @version 0.1
 */
public abstract class Material implements GLEnum
{
    //Variabler
    GLFunc gl = null;
 	
    /**
     * Material constructor
     * @param gl the GLFunc passed on from the spesific Material class
     */ 	
    public Material (GLFunc gl )
    {
        this.gl = gl;	
    }
	
    /**
     * Enables the spesific Material.<br>
     * All subclasses must implement this method.
     * @param sideChoice the constant to indicate which side 
     * of the objekt should have this material, can be GL_FRONT_AND_BACK, 
     * GL_FRONT or GL_BACK.
     */
    public abstract void enableMaterial(int sideChoice);
    
    /**
     * Restores default values
     */
    public void disableMaterial()
    {
    		gl.glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 0); // Setter lysmodellen tilbake til defaultsettingen
    }
}