// Importerer ndvendige pakker
import gl4java.*;			// For  kunne implementere GLEnum (gir tilgang til en rekke fields (variablene i store bokstaver))
import gl4java.utils.glut.*;	// Open GL's "verktyboks"

/**
 * <strong>Description:</strong><br>
 * Supplies a factory method for deciding which subclass of 
 * Material to instantiate.<br>
 * <br><strong>All code is extensively commented in Norwegian.</strong>
 * @author Therese Rsholdt, Grafisk Databehadling 2003, Hi
 * @version 1.0
 */
public class MaterialFactory
{
    //Variabler
    GLFunc gl = null;
    Material newMaterial = null;
    
    /**
     * MaterialFactory constructor
     * @param gl the GLFunc to pass on to the spesific Material class
     */
    public MaterialFactory (GLFunc gl )
    {
        this.gl = gl;	
    }
	
    /**
     * Creates an instance of the desired material
     * @param strMaterial a String representation of the material to create
     * @return the desired Material
     */
    public Material createMaterial ( String strMaterial )
    {
        if (strMaterial.equals("BlueGlass"))
        {
            newMaterial = new BlueGlassMaterial(gl);	
        }
        else if (strMaterial.equals("GreenGlass"))
        {
            newMaterial = new GreenGlassMaterial(gl);	
        }
        else if (strMaterial.equals("SootyGlass"))
        {
            newMaterial = new SootyGlassMaterial(gl);	
        }
        else if (strMaterial.equals("Brass"))
        {
            newMaterial = new BrassMaterial(gl);
        }
        else if (strMaterial.equals("Ebony"))
        {
            newMaterial = new EbonyMaterial(gl);
        }
        else if (strMaterial.equals("Green"))
        {
            newMaterial = new GreenMaterial(gl); 			
        }
        else if (strMaterial.equals("RedSand"))
        {
            newMaterial = new RedSandMaterial(gl);
        }
        else if (strMaterial.equals("YellowSand"))
        {
            newMaterial = new YellowSandMaterial(gl);
        }
        else // Klassen finnes ikke
        {
            System.out.println("Du har feil string som materiale: " + strMaterial);
        }
 		
        return newMaterial;
    }
}